Unit AV16C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

function AV16C(N :Integer; var CX :Array of Complex; INCX :Integer;
                var IERR :Integer): Real;

implementation

function AV16C(N :Integer; var CX :Array of Complex; INCX :Integer;
                var IERR :Integer): Real;
var
I,INCX1,M,MP1,NINCX :Integer;
CTEMP,X :Real;
ARG :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_90;
{  -  FORTRAN }
function C1ABS(ARG: Complex): Real;
begin
Result := Abs(Creal(ARG)) + Abs(Aimag(ARG));
end;
{   - }
begin
{ Result -    AV16C  FORTRANe }
IERR  := 0;
CTEMP  := 0.0;
if ( N  <=  0 ) 
 then goto _70;
X  := 0.0;
INCX1  := Abs(INCX);
if ( INCX1  =  1 ) 
 then goto _20;
NINCX  := N*INCX1;
I := 1;
while ( I<=NINCX ) do
 begin
  CTEMP  := CTEMP + C1ABS(CX[I-1]);
_10:
  inc(I,INCX1);
 end;
Result := CTEMP;
goto _90;
_20:
M  := ((N) Mod (6));
if ( M  =  0 ) 
 then goto _40;
for I:=1 to M do
 begin
  CTEMP  := CTEMP + C1ABS(CX[I-1]);
_30:
 end;
if ( N  <  6 ) 
 then goto _60;
_40:
MP1  := M + 1;
I := MP1;
while ( I<=N ) do
 begin
  CTEMP  := CTEMP + C1ABS(CX[I-1]) + C1ABS(CX[I+0]) +
    C1ABS(CX[I+1]) + C1ABS(CX[I+2]) +
    C1ABS(CX[I+3]) + C1ABS(CX[I+4]);
_50:
  inc(I,6);
 end;
_60:
Result := CTEMP;
goto _90;
_70:
IERR  := 65;
UTAV10(IERR,21);
Result := 0.0;
goto _90;
_90:
exit;
end;

end.
